require 'sketchup.rb'

def selected_one_edge
    mm = Sketchup.active_model
    ss = mm.selection
	ecount = 0
	ed = nil
    ss.each do |ee|
		return nil if not ee.instance_of? Sketchup::Edge
		ed = ee
		ecount+=1
    end
	#print("ecount:  "+ ecount.to_s+"\n")
	#print("edge: " + ed.to_s + "\n")
	#print("faces: " + ed.faces.to_s + "\n")
	return nil if ecount != 1
	fcount = 0
	ed.faces.each do |ff|
		if ff.instance_of? Sketchup::Face
			fcount +=1
		end
	end
	#print("fcount: "+fcount.to_s+"\n")
	return nil if fcount !=2
	return ed
end

def plane_angle
	mm = Sketchup.active_model
	ss = mm.selection
	ed = ss[0]
	angle = ed.faces[0].normal.angle_between ed.faces[1].normal
	angle = angle.radians
	angle = ((angle*100).round).to_f/100
	if angle > 90
		return angle.to_s + " (" + (180-angle).to_s + ")"
	else
		return angle.to_s
	end	
end

if( not file_loaded?("plane_angle.rb") )
	UI.add_context_menu_handler do |menu|
		if menu == nil then 
			UI.messagebox("Error settting context menu handler")
			return
		end
		if selected_one_edge
			menu.add_item("Angle Between Faces: " + plane_angle) {}
		end
	end	
end

file_loaded("plane_angle.rb")
